package br.ufes.nemo.seon.ontoloyasservice.generator.service;

import br.ufes.nemo.seon.ontoloyasservice.oaas.Attribute;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Configuration;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Entity;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OneToMany;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OneToOne;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Relation;
import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ServiceGenerator extends AbstractGenerator {
  private String PATHSERVICE = "service/src/";
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    String ontology = "";
    String level = "";
    Iterable<Configuration> _filter = Iterables.<Configuration>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Configuration.class);
    for (final Configuration configuration : _filter) {
      {
        ontology = configuration.getOntologyShortName().getName().toLowerCase();
        level = configuration.getLevel().getName().toLowerCase();
      }
    }
    Iterable<Entity> _filter_1 = Iterables.<Entity>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Entity.class);
    for (final Entity entity : _filter_1) {
      {
        String _lowerCase = entity.getName().toLowerCase();
        String _plus = ((this.PATHSERVICE + "server/") + _lowerCase);
        String _plus_1 = (_plus + "_server.py");
        fsa.generateFile(_plus_1, this.createServer(entity, ontology));
        String _lowerCase_1 = entity.getName().toLowerCase();
        String _plus_2 = ((this.PATHSERVICE + "service/") + _lowerCase_1);
        String _plus_3 = (_plus_2 + "_service.py");
        fsa.generateFile(_plus_3, this.createService(entity, ontology));
      }
    }
    fsa.generateFile((this.PATHSERVICE + "server/__init__.py"), "");
    fsa.generateFile((this.PATHSERVICE + "server/server_abstract.py"), this.createAbstractServer());
    fsa.generateFile((this.PATHSERVICE + "service/__init__.py"), "");
    if (((!StringExtensions.isNullOrEmpty(ontology)) && (!StringExtensions.isNullOrEmpty(level)))) {
      fsa.generateFile((this.PATHSERVICE + "service/service_abstract.py"), this.createAbstractService(ontology, level));
    }
  }
  
  private CharSequence createAbstractServer() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from rabbitmqX.patterns.server.topic_server import Topic_Server");
    _builder.newLine();
    _builder.newLine();
    _builder.append("class ServerAbstract():");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __init__(self, queue_name, service):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.topic_server = Topic_Server(queue_name,service)");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def start(self):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.topic_server.start()");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createAbstractService(final String ontology, final String level) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("import logging");
    _builder.newLine();
    _builder.append("from pprint import pprint");
    _builder.newLine();
    _builder.append("class ServiceAbstract():");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def do(self,journal):");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("data = journal[\'data\']");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("if data[\"ontology\"] != \"");
    _builder.append(ontology, "            ");
    _builder.append("\" and data[\"level\"] != \"");
    _builder.append(level, "            ");
    _builder.append("\":");
    _builder.newLineIfNotEmpty();
    _builder.append("                ");
    _builder.append("if journal[\'action\'] == \'create\':");
    _builder.newLine();
    _builder.append("                    ");
    _builder.append("self.create(data)");
    _builder.newLine();
    _builder.append("                ");
    _builder.append("elif journal[\'action\'] == \'update\':");
    _builder.newLine();
    _builder.append("                    ");
    _builder.append("self.update(data)");
    _builder.newLine();
    _builder.append("                ");
    _builder.append("else:");
    _builder.newLine();
    _builder.append("                    ");
    _builder.append("self.delete(data)");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("except Exception as e:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(\"OS error: {0}\".format(e))");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(e.__dict__)");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def create(self,data):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("pass");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def update(self,data):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("pass");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def delete(self,data):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("pass");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createServer(final Entity entity, final String ontology) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from .server_abstract import ServerAbstract");
    _builder.newLine();
    _builder.append("from service.");
    String _lowerCase = entity.getName().toLowerCase();
    _builder.append(_lowerCase);
    _builder.append("_service import ");
    String _firstUpper = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper);
    _builder.append("Service");
    _builder.newLineIfNotEmpty();
    _builder.append("from pprint import pprint");
    _builder.newLine();
    _builder.newLine();
    _builder.append("class ");
    String _firstUpper_1 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_1);
    _builder.append("Server(ServerAbstract):");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __init__(self):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("queue_name = \"domain.*.");
    String _lowerCase_1 = ontology.toLowerCase();
    _builder.append(_lowerCase_1, "\t\t");
    _builder.append(".");
    String _lowerCase_2 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_2, "\t\t");
    _builder.append("\"");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("service = ");
    String _firstUpper_2 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_2, "\t\t");
    _builder.append("Service()");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("pprint(\"");
    String _firstUpper_3 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_3, "\t\t");
    _builder.append(" Server\")");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("super().__init__(queue_name=queue_name, service=service)");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createAtribute(final Attribute attribute, final String entityName) {
    StringConcatenation _builder = new StringConcatenation();
    String _lowerCase = entityName.toLowerCase();
    _builder.append(_lowerCase);
    _builder.append(".");
    String _lowerCase_1 = attribute.getName().toLowerCase();
    _builder.append(_lowerCase_1);
    _builder.append(" = data[\'");
    String _lowerCase_2 = attribute.getName().toLowerCase();
    _builder.append(_lowerCase_2);
    _builder.append("\']");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence createRelation(final OneToOne oneToOne, final Entity entity) {
    StringConcatenation _builder = new StringConcatenation();
    String _lowerCase = oneToOne.getName().toLowerCase();
    _builder.append(_lowerCase);
    _builder.append("_uuid = data[\'");
    String _lowerCase_1 = oneToOne.getName().toLowerCase();
    _builder.append(_lowerCase_1);
    _builder.append("\'][\'uuid_\']");
    _builder.newLineIfNotEmpty();
    _builder.append("if ");
    String _lowerCase_2 = oneToOne.getName().toLowerCase();
    _builder.append(_lowerCase_2);
    _builder.append("_uuid is not None:");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _lowerCase_3 = oneToOne.getType().getName().toLowerCase();
    _builder.append(_lowerCase_3, "\t");
    _builder.append("_application = application_factory.");
    String _name = oneToOne.getType().getName();
    _builder.append(_name, "\t");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _lowerCase_4 = oneToOne.getType().getName().toLowerCase();
    _builder.append(_lowerCase_4, "\t");
    _builder.append(" = ");
    String _lowerCase_5 = oneToOne.getType().getName().toLowerCase();
    _builder.append(_lowerCase_5, "\t");
    _builder.append("_application.find_by_uuid(");
    String _lowerCase_6 = oneToOne.getName().toLowerCase();
    _builder.append(_lowerCase_6, "\t");
    _builder.append("_uuid)");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _lowerCase_7 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_7, "\t");
    _builder.append(".");
    String _lowerCase_8 = oneToOne.getName().toLowerCase();
    _builder.append(_lowerCase_8, "\t");
    _builder.append(" = ");
    String _lowerCase_9 = oneToOne.getType().getName().toLowerCase();
    _builder.append(_lowerCase_9, "\t");
    _builder.append(" ");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence createRelation(final OneToMany oneToMany, final Entity entity) {
    StringConcatenation _builder = new StringConcatenation();
    String _lowerCase = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase);
    _builder.append("_array = data[\'");
    String _lowerCase_1 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_1);
    _builder.append("\']");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("if ");
    String _lowerCase_2 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_2);
    _builder.append("_array is not None:");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _lowerCase_3 = oneToMany.getType().getName().toLowerCase();
    _builder.append(_lowerCase_3, "\t");
    _builder.append("_application = application_factory.");
    String _name = oneToMany.getType().getName();
    _builder.append(_name, "\t");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("for ");
    String _lowerCase_4 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_4, "\t");
    _builder.append(" in ");
    String _lowerCase_5 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_5, "\t");
    _builder.append("_array:");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    String _lowerCase_6 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_6, "\t\t");
    _builder.append("_uuid = data[\'");
    String _lowerCase_7 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_7, "\t\t");
    _builder.append("\'][\'uuid_\']");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    String _lowerCase_8 = oneToMany.getType().getName().toLowerCase();
    _builder.append(_lowerCase_8, "\t\t");
    _builder.append(" = ");
    String _lowerCase_9 = oneToMany.getType().getName().toLowerCase();
    _builder.append(_lowerCase_9, "\t\t");
    _builder.append("_application.find_by_uuid(");
    String _lowerCase_10 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_10, "\t\t");
    _builder.append("_uuid)");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    String _lowerCase_11 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_11, "\t\t");
    _builder.append(".");
    String _lowerCase_12 = oneToMany.getName().toLowerCase();
    _builder.append(_lowerCase_12, "\t\t");
    _builder.append(".append(");
    String _lowerCase_13 = oneToMany.getType().getName().toLowerCase();
    _builder.append(_lowerCase_13, "\t\t");
    _builder.append(") ");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence createAttributes(final Entity entity) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Attribute> _attributes = entity.getAttributes();
      for(final Attribute attribute : _attributes) {
        CharSequence _createAtribute = this.createAtribute(attribute, entity.getName().toLowerCase());
        _builder.append(_createAtribute);
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence createRelations(final Entity entity) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Relation> _relations = entity.getRelations();
      for(final Relation relationship : _relations) {
        {
          Class<?> _instanceClass = relationship.eClass().getInstanceClass();
          boolean _equals = Objects.equal(_instanceClass, OneToOne.class);
          if (_equals) {
            final OneToOne onetoone = ((OneToOne) relationship);
            _builder.newLineIfNotEmpty();
            CharSequence _createRelation = this.createRelation(onetoone, entity);
            _builder.append(_createRelation);
            _builder.newLineIfNotEmpty();
          }
        }
        {
          Class<?> _instanceClass_1 = relationship.eClass().getInstanceClass();
          boolean _equals_1 = Objects.equal(_instanceClass_1, OneToMany.class);
          if (_equals_1) {
            final OneToMany onetoMany = ((OneToMany) relationship);
            _builder.newLineIfNotEmpty();
            CharSequence _createRelation_1 = this.createRelation(onetoMany, entity);
            _builder.append(_createRelation_1);
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  private CharSequence createService(final Entity entity, final String ontology) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("import logging");
    _builder.newLine();
    _builder.append("from pprint import pprint");
    _builder.newLine();
    _builder.newLine();
    _builder.append("from ");
    String _lowerCase = ontology.toLowerCase();
    _builder.append(_lowerCase);
    _builder.append("_lib.application import factories as application_factory");
    _builder.newLineIfNotEmpty();
    _builder.append("from ");
    String _lowerCase_1 = ontology.toLowerCase();
    _builder.append(_lowerCase_1);
    _builder.append("_lib.model import factories as model_factory");
    _builder.newLineIfNotEmpty();
    _builder.append("from service.service_abstract import ServiceAbstract");
    _builder.newLine();
    _builder.append("logging.basicConfig(format=\'%(process)d-%(levelname)s-%(message)s\')");
    _builder.newLine();
    _builder.newLine();
    _builder.append("class ");
    String _firstUpper = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper);
    _builder.append("Service(ServiceAbstract):");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def create(self,data):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("pprint (\"");
    String _firstUpper_1 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_1, "            ");
    _builder.append(" Service\") ");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.append("pprint (\"Create\")");
    _builder.newLine();
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_2 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_2, "            ");
    _builder.append(" = model_factory.");
    String _firstUpper_2 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_2, "            ");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    String _lowerCase_3 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_3, "            ");
    _builder.append(".name = data[\'name\']");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    String _lowerCase_4 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_4, "            ");
    _builder.append(".uuid = data[\'uuid\']");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    String _lowerCase_5 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_5, "            ");
    _builder.append(".description = data[\'description\']");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    CharSequence _createAttributes = this.createAttributes(entity);
    _builder.append(_createAttributes, "            ");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    CharSequence _createRelations = this.createRelations(entity);
    _builder.append(_createRelations, "            ");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_6 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_6, "            ");
    _builder.append("_application = application_factory.");
    String _firstUpper_3 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_3, "            ");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    String _lowerCase_7 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_7, "            ");
    _builder.append("_application.create (");
    String _lowerCase_8 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_8, "            ");
    _builder.append(")");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("pprint (\"Created\")");
    _builder.newLine();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("except Exception as e:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(\"OS error: {0}\".format(e))");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(e.__dict__)");
    _builder.newLine();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def update(self,data):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("pprint (\"");
    String _firstUpper_4 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_4, "            ");
    _builder.append(" Service\")  ");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.append("pprint (\"Update\")");
    _builder.newLine();
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_9 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_9, "            ");
    _builder.append("_application = application_factory.");
    String _firstUpper_5 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_5, "            ");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.append("uuid = data[\'uuid\']");
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_10 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_10, "            ");
    _builder.append(" = ");
    String _lowerCase_11 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_11, "            ");
    _builder.append("_application.find_by_uuid(uuid)");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_12 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_12, "            ");
    _builder.append(".name = data[\'name\']");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t\t");
    String _lowerCase_13 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_13, "\t\t\t");
    _builder.append(".description = data[\'description\']");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t\t");
    CharSequence _createAttributes_1 = this.createAttributes(entity);
    _builder.append(_createAttributes_1, "\t\t\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t\t");
    _builder.newLine();
    _builder.append("\t\t\t");
    CharSequence _createRelations_1 = this.createRelations(entity);
    _builder.append(_createRelations_1, "\t\t\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t\t");
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_14 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_14, "            ");
    _builder.append("_application.update (");
    String _lowerCase_15 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_15, "            ");
    _builder.append(")");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("            ");
    _builder.append("pprint (\"");
    String _firstUpper_6 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_6, "            ");
    _builder.append("  Service: Updated\")");
    _builder.newLineIfNotEmpty();
    _builder.append("        ");
    _builder.append("except Exception as e:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(\"OS error: {0}\".format(e))");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(e.__dict__)");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def delete(self, data):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("pprint (\"");
    String _firstUpper_7 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_7, "            ");
    _builder.append(" Service\")  ");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.append("pprint (\"Delete\")   ");
    _builder.newLine();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_16 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_16, "            ");
    _builder.append("_application = application_factory.");
    String _firstUpper_8 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_8, "            ");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("uuid = data[\'uuid\']");
    _builder.newLine();
    _builder.append("            ");
    String _lowerCase_17 = entity.getName().toLowerCase();
    _builder.append(_lowerCase_17, "            ");
    _builder.append("_application.delete(uuid)");
    _builder.newLineIfNotEmpty();
    _builder.append("            ");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("pprint (\"");
    String _firstUpper_9 = StringExtensions.toFirstUpper(entity.getName());
    _builder.append(_firstUpper_9, "            ");
    _builder.append(" Service\": Deleted\")");
    _builder.newLineIfNotEmpty();
    _builder.append("        ");
    _builder.append("except Exception as e:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(\"OS error: {0}\".format(e))");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("logging.error(e.__dict__)");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
